<?php

class ACMS_POST_Form_Submit extends ACMS_POST_Form
{
    function post()
    {
        $Option = new Field();
        $_Mail  = new Field();
        $fmid   = null;
        $fmeid  = $this->Post->get('eid');

        $DB     = DB::singleton(dsn());
        if ( !!($code = $this->Post->get('id')) ) {
            $SQL    = SQL::newSelect('form');
            $SQL->addWhereOpr('form_code', $code);
            $SQL->addWhereOpr('form_blog_id', BID);
            if ( $row = $DB->query($SQL->get(dsn()), 'row') ) {
                $fmid   = intval($row['form_id']);
                $Form   = unserialize($row['form_data']);
                $Option->overload($Form->getChild('option'));
                $_Mail->overload($Form->getChild('mail'));
            }
        }

        $Field  =& $this->extract('field');

        foreach ( $Option->getArray('field') as $i => $fd ) {
            if ( empty($fd) ) continue;
            if ( !($method = $Option->get('method', '', $i)) ) continue;
            $value  = $Option->get('value', '', $i);
            if ( 'converter' == $method ) {
                $this->Post->set($fd.':converter', $value);
            } elseif ( 'duplication' == $method ) {
                $dup[] = $fd;
                $dup[] = $row['form_id'];
                $dup[] = $Field->get($fd);
            } else {
                $this->Post->set($fd.':validator#'.$method, $value);
            }
        }

        if( !empty($dup) ) {
            list($fd, $id, $mail) = $dup;
            $Field->setMethod($fd, 'duplication', $this->mailToDouble($id, $mail));
        }
        $Field->validate(new ACMS_Validator());

        if ( $this->Post->isValidAll() ) {
            //--------------------------------
            // serial number ※フォームIDがあれば
            if ( !!$fmid ) {
                $SQL = SQL::newUpdate('form');
                $SQL->addWhereOpr('form_id', $fmid);
                $SQL->setUpdate('form_current_serial',
                    SQL::newFunction(SQL::newOpr('form_current_serial', 1, '+'), 'LAST_INSERT_ID')
                );
                $Field->set('serialNumber', $DB->query($SQL->get(dsn()), 'seq'));
            } else {
                $Field->set('serialNumber', '');
            }

            //------
            // mail
            $this->Post->set('acms_field_mail', array(
                'To', 'SubjectTpl', 'BodyTpl', 'Charset', 'Obfuscation',
                'Sender', 'From', 'Reply-To', 'Cc', 'Bcc',
                'AdminTo', 'AdminSubjectTpl', 'AdminBodyTpl', 
                'AdminFrom', 'AdminReply-To', 'AdminCc', 'AdminBcc',
            ));
            $Mail   =& $this->extract('acms_field_mail');
            $Mail->overload($_Mail);

            if ( !!$Mail->get('Obfuscation') ) {
                foreach ( array(
                    'To', 'Sender', 'From', 'Reply-To', 'Cc', 'Bcc',
                    'AdminTo', 'AdminFrom', 'AdminReply-To', 'AdminCc', 'AdminBcc',
                ) as $field ) {
                    $values = array();
                    foreach ( $Mail->getArray($field) as $value ) {
                        $values[]   = base64_decode($value);
                    }
                    $Mail->set($field, $values);
                }
            }

            $charset    = $Mail->get('Charset', 'ISO-2022-JP');
            $sender     = $Mail->get('Sender');

            if ( 1
                and $to = $Mail->getArray('To')
                and $subjectTpl = findTemplate($Mail->get('SubjectTpl'))
                and $bodyTpl = findTemplate($Mail->get('BodyTpl'))
            ) {
                $Mail->set('subject', $this->getMailTxt($subjectTpl, $Field));
                $Mail->set('body', $this->getMailTxt($bodyTpl, $Field));

                $FormMail   = new Mail($this->mailConfig());
                $FormMail->setHeaderReturnPath();
                $FormMail->setHeaderDate();
                $FormMail->setHeaderMessageId();
                $FormMail->setHeader('Sender', $sender);
                $FormMail->setHeader('From', $Mail->getArray('From'));
                $FormMail->setHeader('To', $to);
                $FormMail->setHeader('Subject', $Mail->get('subject'));
                $FormMail->setHeader('Cc', $Mail->getArray('Cc'));
                $FormMail->setHeader('Bcc', $Mail->getArray('Bcc'));
                $FormMail->setHeader('Reply-To', $Mail->getArray('Reply-To'));
                $FormMail->setHeader('MIME-Version', '1.0');
                $FormMail->setHeader('Content-Type', 'text/plain', array('charset' => $charset));
                $FormMail->setHeader('Content-Transfer-Encoding', ('ISO-2022-JP' == $charset) ? '7bit' : 'base64');
                $FormMail->setBody($Mail->get('body'));

                $FormMail->send();
            }

            if ( 1
                and $to = $Mail->getArray('AdminTo')
                and $subjectTpl = findTemplate($Mail->get('AdminSubjectTpl'))
                and $bodyTpl = findTemplate($Mail->get('AdminBodyTpl'))
            ) {
                $Mail->set('adminSubject', $this->getMailTxt($subjectTpl, $Field));
                $Mail->set('adminBody', $this->getMailTxt($bodyTpl, $Field));
				
                $FormMail   = new ACMS_POST_Form_Mail($this->mailConfig());
                $FormMail->setHeaderReturnPath();
                $FormMail->setHeaderDate();
                $FormMail->setHeaderMessageId();
                $FormMail->setHeader('Sender', $sender);
                $FormMail->setHeader('From', $Mail->getArray('AdminFrom'));
                $FormMail->setHeader('To', $to);
                $FormMail->setHeader('Subject', $Mail->get('adminSubject'));
                $FormMail->setHeader('Cc', $Mail->getArray('AdminCc'));
                $FormMail->setHeader('Bcc', $Mail->getArray('AdminBcc'));
                $FormMail->setHeader('Reply-To', $Mail->getArray('AdminReply-To'));
                $FormMail->setHeader('MIME-Version', '1.0');

                //------------
                // 添付ファイル
                $ary_attachfile = array();
                $flg_addfile    = false;
                if( $Mail->get('AdminAttachment') == 'on' ){
                    foreach ( $Field->listFields() as $fd ) {
                        $bool_addfile = FALSE;
                        if ( 1
                            and preg_match('@^(.+)\@baseName$@', $fd, $match)
                            and $Field->isExists($match[1])
                        ) {
                            $fd_file = $match[1];
                            $str_filename = $Field->get($fd_file . '@baseName');
                            $str_orginfile = $Field->get($fd_file . '@path');
                            $realpath = ARCHIVES_DIR.$str_orginfile;
                            $ary_attachfile[] = $realpath;
                            if( strlen( $str_filename ) == 0 ){
                                if ( file_exists($realpath) && is_file($realpath) ) {
                                     $str_filename = basename($realpath);
                                }
                            }
                            $temppath = ARCHIVES_DIR.config('mail_attachment_temp_dir').$str_filename;
                            if ( file_exists($temppath) && is_file($temppath) ) {
                                $bool_addfile = $FormMail->addFile( $temppath );
                                if( $bool_addfile !== FALSE ){
                                    $ary_attachfile[] = $temppath;
                                    $flg_addfile = TRUE;
                                }
                            }
                        }
                    }
                    if( $flg_addfile !== false ){
                        $FormMail->setHeader('Content-Type', 'multipart/mixed', array(
                            'boundary' => 'ablogcms-'.uniqid('boundary'),
                        ));
                    }
                }

                //----------------------
                // plain text (添付あり)
                var_dump(count( $ary_attachfile ));
                if ( $Mail->get('AdminAttachment') == 'on' && ( count( $ary_attachfile ) > 0 ) ) {
                    $Plain  =& new Mail();
                    $Plain->setHeader('Content-Type', 'text/plain', array(
                        'charset' => $charset,
                    ));
                    $Plain->setHeader('Content-Transfer-Encoding', ('ISO-2022-JP' == $charset) ? '7bit' : 'base64');
                    $Plain->setBody($Mail->get('adminBody'));
                    $FormMail->addBody($Plain);
                //----------------------
                // plain text (添付なし)
                } else {
                    $FormMail->setHeader('Content-Type', 'text/plain', array(
                        'charset' => $charset,
                    ));
                    $FormMail->setHeader('Content-Transfer-Encoding', ('ISO-2022-JP' == $charset) ? '7bit' : 'base64');
                    $FormMail->setBody($Mail->get('adminBody'));
                }

                $FormMail->send();

                //---------------
                // 添付ファイル削除
                if ( $Mail->get('AdminAttachment') == 'on' && ( count( $ary_attachfile ) > 0 ) ) {
                    foreach($ary_attachfile as $del_file ){
                        @unlink( $del_file );
                        $base_file = ARCHIVES_DIR.basename($del_file);
                        if ( file_exists($base_file) && is_file($base_file) ) {
                            @unlink( $base_file );
                            if ( HOOK_ENABLE ) {
                                $Hook = ACMS_Hook::singleton();
                                $Hook->call('mediaDelete', $base_file);
                            }
                        }
                    }
                }
            }


            if ( !empty($fmid) ) {
                $SQL    = SQL::newInsert('log_form');
                $SQL->addInsert('log_form_datetime', date('Y-m-d H:i:s', REQUEST_TIME));
                $SQL->addInsert('log_form_remote_addr', REMOTE_ADDR);
                $SQL->addInsert('log_form_user_agent', UA);
                $SQL->addInsert('log_form_mail_to', strval(join(', ', $Mail->getArray('To'))));
                $SQL->addInsert('log_form_mail_subject', strval($Mail->get('subject')));
                $SQL->addInsert('log_form_mail_body', strval($Mail->get('body')));
                $SQL->addInsert('log_form_data', serialize($Field));
                $SQL->addInsert('log_form_serial', $Field->get('serialNumber'));

                $SQL->addInsert('log_form_entry_id', $fmeid);
                $SQL->addInsert('log_form_form_id', $fmid);
                $SQL->addInsert('log_form_blog_id', BID);
                $DB->query($SQL->get(dsn()), 'exec');
            }
        }

        return $this->Post;
    }
}
